include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 100000		; 1000000 would be a typical value
.xmm

.data
align 16
	db "xxxxxxxxxx"
	db 0
Src1	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos.", 0
My$	dd Src1

.code
start:
	push 1
	call ShowCpu	; print brand string and SSE level

	REPEAT 2
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push My$
		call StrLen1
	counter_end
	print str$(eax), 9, "cycles for StrLen1", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push My$
		call StrLen2
	counter_end
	print str$(eax), 9, "cycles for StrLen2", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push My$
		call MbStrLen
	counter_end
	print str$(eax), 9, "cycles for MasmBasic", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov eax, len(My$)
	counter_end
	print str$(eax), 9, "cycles for MasmLib", 13, 10, 10
	ENDM

	print "Results:", 13, 10
	push My$
	call StrLen1
	print str$(eax), " bytes for StrLen1", 13, 10
	push My$
	call StrLen2
	print str$(eax), " bytes for StrLen2", 13, 10
	push My$
	call MbStrLen
	print str$(eax), " bytes for MasmBasic", 13, 10, 10
	print "Code sizes:", 13, 10
	mov eax, StrLen1_endp
	sub eax, StrLen1_s
	print str$(eax), 9, "for StrLen1", 13, 10
	mov eax, StrLen2_endp
	sub eax, StrLen2_s
	print str$(eax), 9, "for StrLen2", 13, 10
	mov eax, MbStrLen_endp
	sub eax, MbStrLen_s
	print str$(eax), 9, "for MasmBasic", 13, 10
	getkey
	exit
align 16
StrLen1_s:
StrLen1 proc uses ecx edx ebx	; src:DWORD (pseudo arg; uncommenting adds frame!)
	mov eax, [esp+4+3*4]	; get the src pointer
	pxor xmm0, xmm0		; zero xmm0 for finding zero bytes
	movaps xmm1, xmm0	; same for xmm1
	mov ecx, eax
	and eax, -16
	sub ecx, eax		; misalignment
@@:
	pcmpeqb xmm0, [eax+16]	; ---- inner loop inspired by Lingo, with adaptions -----
	pcmpeqb xmm1, [eax]	; compare packed bytes in [m128] and xmm1 for equality
	if 1
	add eax, 32		; len counter
	else
	lea eax, [eax+32]		; len counter
	endif
	pmovmskb ebx, xmm0	; set byte mask in ebx
	shl ebx, 16		; create space for the ecx bytes
	pmovmskb edx, xmm1	; set byte mask in edx
	or edx, ebx
	jz @B
	if 0
		test ecx, ecx
		je @F
	else
		jecxz @F
	endif
	shr edx, cl
	shl edx, cl
	mov cl, 0			; we need the flag
	je @B			; no success yet
@@:	sub eax, [esp+4+3*4]	; subtract original src pointer
	bsf edx, edx		; bit scan for the index
	lea eax, [eax+edx-32]	; add scan index
Lt16:	ret 4
StrLen1 endp
StrLen1_endp:

align 16
StrLen2_s:
StrLen2 proc uses ecx edx ebx	; src:DWORD (pseudo arg; uncommenting adds frame!)
	mov eax, [esp+4+3*4]	; get the src pointer
	pxor xmm0, xmm0		; zero xmm0 for finding zero bytes
	movaps xmm1, xmm0	; same for xmm1
	mov ecx, eax
	and eax, -16
	sub ecx, eax		; misalignment
	jmp L1
@@:	add eax, 32
L1:	pcmpeqb xmm0, [eax+16]	; ---- inner loop inspired by Lingo, with adaptions -----
	pcmpeqb xmm1, [eax]	; compare packed bytes in [m128] and xmm1 for equality
	pmovmskb ebx, xmm0	; set byte mask in ebx
	shl ebx, 16		; create space for the ecx bytes
	pmovmskb edx, xmm1	; set byte mask in edx
	or edx, ebx
	jz @B
	jecxz @F
	shr edx, cl
	shl edx, cl
	mov cl, 0			; we need the flag
	je @B			; no success yet
@@:	bsf edx, edx		; bit scan for the index
	sub eax, [esp+4+3*4]	; subtract original src pointer
	add eax, edx		; add scan index
Lt16:	ret 4
StrLen2 endp
StrLen2_endp:

align 16
MbStrLen_s:
MbStrLen proc ; src:DWORD (pseudo arg; uncommenting adds frame!) - with lots of inspiration from Lingo, NightWare and Agner Fog
	pop eax			; trash the return address (still on stack, though)
	pop eax			; get the src pointer
	pxor xmm0, xmm0		; zero xmm0 for finding zero bytes
	mov [esp-12], edx		; edx preserved because Masm32 szLen preserves it
	movups xmm1, [eax]	; move 16 bytes into xmm1, unaligned (adapted from Lingo/NightWare)
;	int 3	; OPT_Olly 2
	pcmpeqb xmm1, xmm0	; set bytes in xmm1 to FF if nullbytes found in xmm1
	mov edx, eax		; save pointer to string
	pmovmskb eax, xmm1	; set byte mask in eax
	test eax, eax		; any bit set?
	jne Lt16			; less than 16 bytes, we are done
	and edx, -16		; align initial pointer to 16-byte boundary
	lea eax, [edx+16]		; aligned pointer + 16 (first 0..15 dealt with by movups above)

@@:	pcmpeqb xmm0, [eax]	; ---- inner loop inspired by Lingo, with adaptions -----
	pcmpeqb xmm1, [eax+16]	; compare packed bytes in [m128] and xmm1 for equality
	lea eax, [eax+32]		; len counter (moving up lea or add costs 3 cycles for the 191 byte string)
	; the por xmm1, xmm0 speeds up the algo but requires some repetition below...
	por xmm1, xmm0		; or them: one of the mem locations may contain a nullbyte
	pmovmskb edx, xmm1	; set byte mask in edx
	test edx, edx
	jz @B

	sub eax, [esp-4]		; subtract original src pointer
	shl edx, 16		; create space for the ecx bytes
	push ecx			; this push trashes the src pointer (all registers preserved, except eax = return value)
	pmovmskb ecx, xmm0	; set byte mask in ecx (has to be repeated, sorry)
	or edx, ecx		; combine xmm0 and xmm1 results
	bsf edx, edx		; bit scan for the index
	pop ecx
	lea eax, [eax+edx-32]	; add scan index
Lt16:	mov edx, [esp-12]		; for saving edx, we use a free stack slot; -8 is the ret address
	jmp dword ptr [esp-2*4]	; ret address, one arg
MbStrLen endp
MbStrLen_endp:

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

OPT_Tmp2Asm	1
OPT_Wait	0
